'use strict';

exports.__esModule = true;
var isFunction = exports.isFunction = function isFunction(item) {
    return typeof item === 'function';
};
var isNumber = exports.isNumber = function isNumber(item) {
    return typeof item === 'number' && !isNaN(item);
};
var isString = exports.isString = function isString(item) {
    return typeof item === 'string';
};
var isArray = exports.isArray = function isArray(item) {
    return item.constructor === Array;
};
var isEmptyString = exports.isEmptyString = function isEmptyString(item) {
    return isString(item) && !item;
};

var assignFunction = exports.assignFunction = function assignFunction(item) {
    if (isFunction(item)) {
        return item;
    }
};

var assignNumber = exports.assignNumber = function assignNumber(number, defaultNumber, listLength) {
    if (isNumber(number)) {
        if (number === 0) {
            return listLength;
        }

        return number;
    }

    return defaultNumber;
};